
!# libxlsxwriter for Clarion
!# based on libxlsxwriter.dll 0.7.5
!# https://libxlsxwriter.github.io 
!# RaFaeL 13.12.2017

     MAP
            MODULE('WIN API')
             OMIT('***',_WIDTH32_)
                             ShellExecute(UNSIGNED,*CSTRING,*CSTRING,LONG=0,LONG=0,SIGNED=1),UNSIGNED,PASCAL,RAW
                               ***
                                COMPILE('***',_WIDTH32_)
                ShellExecute(UNSIGNED,*CSTRING,*CSTRING,LONG=0,LONG=0,SIGNED=1),UNSIGNED,PASCAL,RAW,NAME('ShellExecuteA')
         ***
    GetSysColor(SIGNED),ULONG,PASCAL
    WideCharToMultiByte(long,long,*CSTRING,long,*CSTRING,long,long,long),LONG,PASCAL,RAW,PROC
    MultiByteToWideChar(long,long,*CSTRING,long,*CSTRING,long),LONG,PASCAL,RAW,PROC
  END

  MODULE('xlsxwriter.clw')
    RGBColor(LONG color),LONG
    GetSystemColor(LONG Color),LONG
    ConvertCharSet(*cstring sIn,long in_,long out_)
  END
 END

COMPILE('***',_TPICTLinkMode_)
 include('tpicture.inc'),once
***

XLSX:BorderLeft          EQUATE(1)
XLSX:BorderTop           EQUATE(2)
XLSX:BorderRight         EQUATE(4)
XLSX:BorderBottom        EQUATE(8)

XLSX:BORDER_NONE                  EQUATE(0)
XLSX:BORDER_THIN                  EQUATE(1)
XLSX:BORDER_MEDIUM                EQUATE(2)
XLSX:BORDER_DASHED                EQUATE(3)
XLSX:BORDER_DOTTED                EQUATE(4)
XLSX:BORDER_THICK                 EQUATE(5)
XLSX:BORDER_DOUBLE                EQUATE(6)
XLSX:BORDER_HAIR                  EQUATE(7)
XLSX:BORDER_MEDIUM_DASHED         EQUATE(8)
XLSX:BORDER_DASH_DOT              EQUATE(9)
XLSX:BORDER_MEDIUM_DASH_DOT       EQUATE(10)
XLSX:BORDER_DASH_DOT_DOT          EQUATE(11)
XLSX:BORDER_MEDIUM_DASH_DOT_DOT   EQUATE(12)
XLSX:BORDER_SLANT_DASH_DOT        EQUATE(13)

XLSX:ALIGN_NONE          EQUATE(0)
XLSX:ALIGN_LEFT          EQUATE(1)
XLSX:ALIGN_CENTER        EQUATE(2)
XLSX:ALIGN_RIGHT         EQUATE(3)
XLSX:ALIGN_FILL          EQUATE(4)
XLSX:ALIGN_JUSTIFY       EQUATE(5)
XLSX:ALIGN_CENTER_ACROSS EQUATE(6)
XLSX:ALIGN_DISTRIBUTED   EQUATE(7)

XLSX:ALIGN_VERTICAL_TOP         EQUATE(8)
XLSX:ALIGN_VERTICAL_BOTTOM      EQUATE(9)
XLSX:ALIGN_VERTICAL_CENTER      EQUATE(10)
XLSX:ALIGN_VERTICAL_JUSTIFY     EQUATE(11)
XLSX:ALIGN_VERTICAL_DISTRIBUTED EQUATE(12)

XLSX:HIDE_ALL_GRIDLINES     EQUATE(0)
XLSX:SHOW_SCREEN_GRIDLINES  EQUATE(1)
XLSX:SHOW_PRINT_GRIDLINES   EQUATE(2)
XLSX:SHOW_ALL_GRIDLINES     EQUATE(3)

datetime GROUP,TYPE
year       LONG
month      LONG
day        LONG
hour       LONG
min        LONG
sec        REAL
 END

imageoptions GROUP,TYPE
x_offset    LONG
y_offset    LONG
x_scale     REAL
y_scale     REAL
row         LONG
col         LONG
filename    LONG
url         LONG
tip         LONG
 END

hf_options GROUP,TYPE
margin      REAL
 END

rc_options GROUP,TYPE
hidden      BYTE
level       BYTE
collapsed   BYTE
 END

doc_properties GROUP,TYPE
title       LONG
subject     LONG
author      LONG
manager     LONG
company     LONG
category    LONG
keywords    LONG
comments    LONG
status      LONG
hyperlink_base LONG
 END

FormatType GROUP,TYPE
BorderStyle BYTE
BorderColor LONG
BorderFormat BYTE(XLSX:BORDER_THIN)
Color       LONG
FontName    CSTRING(101)
FontSize    REAL
FontColor   LONG
FontStyle   LONG
Align       BYTE
AlignV      BYTE
WrapText    BYTE
Picture     CSTRING(101)
 END

FormatQType Queue,TYPE
FormatG       GROUP(FormatType)
              END
Ref           LONG
            END

xlsxwriter                    CLASS, TYPE, MODULE('xlsxwriter.clw'), LINK('xlsxwriter.clw')
Workbook                        LONG
ActiveWorksheet                 LONG
Filename                        CSTRING(256)

Properties                      GROUP
title                             CSTRING(256)
subject                           CSTRING(256)
author                            CSTRING(256)
manager                           CSTRING(256)
company                           CSTRING(256)
category                          CSTRING(256)
keywords                          CSTRING(256)
comments                          CSTRING(256)
status                            CSTRING(256)
hyperlink_base                    CSTRING(256)
                                END

ActiveFormat                    LONG

Format                          GROUP(FormatType)
                                END

FormatQ                         &FormatQType

 COMPILE('***',_TPictureClassPresent_)
Picture                         &TPictureClass
 ***

Construct                       PROCEDURE
Destruct                        PROCEDURE
NewWorkbook                     PROCEDURE(STRING Filename_)
AddWorksheet                    PROCEDURE(STRING Sheetname_),LONG
CloseWorkbook                   PROCEDURE(),LONG
SetProperties                   PROCEDURE(),LONG

WriteNumber                     PROCEDURE(LONG row_,LONG col_,REAL number_),LONG
WriteBoolean                    PROCEDURE(LONG row_,LONG col_,SHORT value_),LONG
WriteString                     PROCEDURE(LONG row_,LONG col_,STRING string_),LONG
WriteUrl                        PROCEDURE(LONG row_,LONG col_,STRING url_),LONG
WriteBlank                      PROCEDURE(LONG row_,LONG col_),LONG
WriteDateTime                   PROCEDURE(LONG row_,LONG col_,LONG date_,LONG Time_),LONG
WriteFormula                    PROCEDURE(LONG row_,LONG col_,STRING formula_,<REAL result>),LONG
Merge                           PROCEDURE(LONG first_row_,LONG first_col_,LONG last_row_,LONG last_col_),LONG
Autofilter                      PROCEDURE(LONG first_row_,LONG first_col_,LONG last_row_,LONG last_col_),LONG
SetSelection                    PROCEDURE(LONG first_row_,LONG first_col_,LONG last_row_,LONG last_col_)
SetColumn                       PROCEDURE(LONG first_col_,LONG last_col_,REAL width_,<BYTE hidden_>),LONG
SetRow                          PROCEDURE(LONG row_,REAL height_,<BYTE hidden_>),LONG
ClearFormat                     PROCEDURE()
SetFormat                       PROCEDURE()
SetZoom                         PROCEDURE(SHORT scale_)
SetPrintScale                   PROCEDURE(SHORT scale_)
SetStartPage                    PROCEDURE(SHORT start_page_)
Gridlines                       PROCEDURE(BYTE option_)
FreezePanes                     PROCEDURE(LONG row_,LONG col_)
SplitPanes                      PROCEDURE(REAL vertical_,REAL horizontal_)
HideZero                        PROCEDURE()
InsertImage                     PROCEDURE(LONG row_,LONG col_,STRING filename_,<LONG x_offset_>,<LONG y_offset_>,<REAL x_scale_>,<REAL y_scale_>),LONG
PrintAcross                     PROCEDURE()
PrintRowColHeaders              PROCEDURE()
PrintArea                       PROCEDURE(LONG first_row_,LONG first_col_,LONG last_row_,LONG last_col_),LONG
RepeatRows                      PROCEDURE(LONG first_row_,LONG last_row_),LONG
RepeatColumns                   PROCEDURE(LONG first_col_,LONG last_col_),LONG
SetTabColor                     PROCEDURE(LONG color_)
SetLandscape                    PROCEDURE()
SetPortrait                     PROCEDURE()
SetPaper                        PROCEDURE(BYTE paper_type_)
SetCenterHorizontally           PROCEDURE()
SetCenterVertically             PROCEDURE()
SetPageView                     PROCEDURE()
SetMargins                      PROCEDURE(REAL left_,REAL right_,REAL top_,REAL bottom_)
SetHeader                       PROCEDURE(STRING string_,<REAL margin_>),LONG
SetFooter                       PROCEDURE(STRING string_,<REAL margin_>),LONG
StrError                        PROCEDURE(LONG error_num_),STRING

                              END